package com.rebusland.fin.derivatives.eq.server.output.model;

import org.joda.beans.ImmutableBean;
import org.joda.beans.gen.BeanDefinition;
import org.joda.beans.gen.PropertyDefinition;

import com.rebusland.fin.derivatives.eq.server.common.model.SerializableBeanFacade;
import java.util.Map;
import java.util.NoSuchElementException;
import org.joda.beans.Bean;
import org.joda.beans.JodaBeanUtils;
import org.joda.beans.MetaBean;
import org.joda.beans.MetaProperty;
import org.joda.beans.impl.direct.DirectFieldsBeanBuilder;
import org.joda.beans.impl.direct.DirectMetaBean;
import org.joda.beans.impl.direct.DirectMetaProperty;
import org.joda.beans.impl.direct.DirectMetaPropertyMap;

@BeanDefinition
public class PricingResults extends SerializableBeanFacade implements ImmutableBean {
	@PropertyDefinition(validate = "notNull")
	private final FairPricingOutput price;

	@PropertyDefinition(validate = "notNull")
	private final FairPricingOutput delta;

	@PropertyDefinition
	private final FairPricingOutput gamma;

	@PropertyDefinition
	private final StatisticalResults statisticalResults;

	//------------------------- AUTOGENERATED START -------------------------
	/**
	 * The meta-bean for {@code PricingResults}.
	 * @return the meta-bean, not null
	 */
	public static PricingResults.Meta meta() {
		return PricingResults.Meta.INSTANCE;
	}

	static {
		MetaBean.register(PricingResults.Meta.INSTANCE);
	}

	/**
	 * Returns a builder used to create an instance of the bean.
	 * @return the builder, not null
	 */
	public static PricingResults.Builder builder() {
		return new PricingResults.Builder();
	}

	/**
	 * Restricted constructor.
	 * @param builder  the builder to copy from, not null
	 */
	protected PricingResults(PricingResults.Builder builder) {
		JodaBeanUtils.notNull(builder.price, "price");
		JodaBeanUtils.notNull(builder.delta, "delta");
		this.price = builder.price;
		this.delta = builder.delta;
		this.gamma = builder.gamma;
		this.statisticalResults = builder.statisticalResults;
	}

	@Override
	public PricingResults.Meta metaBean() {
		return PricingResults.Meta.INSTANCE;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the price.
	 * @return the value of the property, not null
	 */
	public FairPricingOutput getPrice() {
		return price;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the delta.
	 * @return the value of the property, not null
	 */
	public FairPricingOutput getDelta() {
		return delta;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the gamma.
	 * @return the value of the property
	 */
	public FairPricingOutput getGamma() {
		return gamma;
	}

	//-----------------------------------------------------------------------
	/**
	 * Gets the statisticalResults.
	 * @return the value of the property
	 */
	public StatisticalResults getStatisticalResults() {
		return statisticalResults;
	}

	//-----------------------------------------------------------------------
	/**
	 * Returns a builder that allows this bean to be mutated.
	 * @return the mutable builder, not null
	 */
	public Builder toBuilder() {
		return new Builder(this);
	}

	@Override
	public boolean equals(Object obj) {
		if (obj == this) {
			return true;
		}
		if (obj != null && obj.getClass() == this.getClass()) {
			PricingResults other = (PricingResults) obj;
			return JodaBeanUtils.equal(price, other.price) &&
					JodaBeanUtils.equal(delta, other.delta) &&
					JodaBeanUtils.equal(gamma, other.gamma) &&
					JodaBeanUtils.equal(statisticalResults, other.statisticalResults);
		}
		return false;
	}

	@Override
	public int hashCode() {
		int hash = getClass().hashCode();
		hash = hash * 31 + JodaBeanUtils.hashCode(price);
		hash = hash * 31 + JodaBeanUtils.hashCode(delta);
		hash = hash * 31 + JodaBeanUtils.hashCode(gamma);
		hash = hash * 31 + JodaBeanUtils.hashCode(statisticalResults);
		return hash;
	}

	@Override
	public String toString() {
		StringBuilder buf = new StringBuilder(160);
		buf.append("PricingResults{");
		int len = buf.length();
		toString(buf);
		if (buf.length() > len) {
			buf.setLength(buf.length() - 2);
		}
		buf.append('}');
		return buf.toString();
	}

	protected void toString(StringBuilder buf) {
		buf.append("price").append('=').append(JodaBeanUtils.toString(price)).append(',').append(' ');
		buf.append("delta").append('=').append(JodaBeanUtils.toString(delta)).append(',').append(' ');
		buf.append("gamma").append('=').append(JodaBeanUtils.toString(gamma)).append(',').append(' ');
		buf.append("statisticalResults").append('=').append(JodaBeanUtils.toString(statisticalResults)).append(',').append(' ');
	}

	//-----------------------------------------------------------------------
	/**
	 * The meta-bean for {@code PricingResults}.
	 */
	public static class Meta extends DirectMetaBean {
		/**
		 * The singleton instance of the meta-bean.
		 */
		static final Meta INSTANCE = new Meta();

		/**
		 * The meta-property for the {@code price} property.
		 */
		private final MetaProperty<FairPricingOutput> price = DirectMetaProperty.ofImmutable(
				this, "price", PricingResults.class, FairPricingOutput.class);
		/**
		 * The meta-property for the {@code delta} property.
		 */
		private final MetaProperty<FairPricingOutput> delta = DirectMetaProperty.ofImmutable(
				this, "delta", PricingResults.class, FairPricingOutput.class);
		/**
		 * The meta-property for the {@code gamma} property.
		 */
		private final MetaProperty<FairPricingOutput> gamma = DirectMetaProperty.ofImmutable(
				this, "gamma", PricingResults.class, FairPricingOutput.class);
		/**
		 * The meta-property for the {@code statisticalResults} property.
		 */
		private final MetaProperty<StatisticalResults> statisticalResults = DirectMetaProperty.ofImmutable(
				this, "statisticalResults", PricingResults.class, StatisticalResults.class);
		/**
		 * The meta-properties.
		 */
		private final Map<String, MetaProperty<?>> metaPropertyMap$ = new DirectMetaPropertyMap(
				this, null,
				"price",
				"delta",
				"gamma",
				"statisticalResults");

		/**
		 * Restricted constructor.
		 */
		protected Meta() {
		}

		@Override
		protected MetaProperty<?> metaPropertyGet(String propertyName) {
			switch (propertyName.hashCode()) {
				case 106934601:  // price
					return price;
				case 95468472:  // delta
					return delta;
				case 98120615:  // gamma
					return gamma;
				case 2135544315:  // statisticalResults
					return statisticalResults;
			}
			return super.metaPropertyGet(propertyName);
		}

		@Override
		public PricingResults.Builder builder() {
			return new PricingResults.Builder();
		}

		@Override
		public Class<? extends PricingResults> beanType() {
			return PricingResults.class;
		}

		@Override
		public Map<String, MetaProperty<?>> metaPropertyMap() {
			return metaPropertyMap$;
		}

		//-----------------------------------------------------------------------
		/**
		 * The meta-property for the {@code price} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<FairPricingOutput> price() {
			return price;
		}

		/**
		 * The meta-property for the {@code delta} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<FairPricingOutput> delta() {
			return delta;
		}

		/**
		 * The meta-property for the {@code gamma} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<FairPricingOutput> gamma() {
			return gamma;
		}

		/**
		 * The meta-property for the {@code statisticalResults} property.
		 * @return the meta-property, not null
		 */
		public final MetaProperty<StatisticalResults> statisticalResults() {
			return statisticalResults;
		}

		//-----------------------------------------------------------------------
		@Override
		protected Object propertyGet(Bean bean, String propertyName, boolean quiet) {
			switch (propertyName.hashCode()) {
				case 106934601:  // price
					return ((PricingResults) bean).getPrice();
				case 95468472:  // delta
					return ((PricingResults) bean).getDelta();
				case 98120615:  // gamma
					return ((PricingResults) bean).getGamma();
				case 2135544315:  // statisticalResults
					return ((PricingResults) bean).getStatisticalResults();
			}
			return super.propertyGet(bean, propertyName, quiet);
		}

		@Override
		protected void propertySet(Bean bean, String propertyName, Object newValue, boolean quiet) {
			metaProperty(propertyName);
			if (quiet) {
				return;
			}
			throw new UnsupportedOperationException("Property cannot be written: " + propertyName);
		}

	}

	//-----------------------------------------------------------------------
	/**
	 * The bean-builder for {@code PricingResults}.
	 */
	public static class Builder extends DirectFieldsBeanBuilder<PricingResults> {

		private FairPricingOutput price;
		private FairPricingOutput delta;
		private FairPricingOutput gamma;
		private StatisticalResults statisticalResults;

		/**
		 * Restricted constructor.
		 */
		protected Builder() {
		}

		/**
		 * Restricted copy constructor.
		 * @param beanToCopy  the bean to copy from, not null
		 */
		protected Builder(PricingResults beanToCopy) {
			this.price = beanToCopy.getPrice();
			this.delta = beanToCopy.getDelta();
			this.gamma = beanToCopy.getGamma();
			this.statisticalResults = beanToCopy.getStatisticalResults();
		}

		//-----------------------------------------------------------------------
		@Override
		public Object get(String propertyName) {
			switch (propertyName.hashCode()) {
				case 106934601:  // price
					return price;
				case 95468472:  // delta
					return delta;
				case 98120615:  // gamma
					return gamma;
				case 2135544315:  // statisticalResults
					return statisticalResults;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
		}

		@Override
		public Builder set(String propertyName, Object newValue) {
			switch (propertyName.hashCode()) {
				case 106934601:  // price
					this.price = (FairPricingOutput) newValue;
					break;
				case 95468472:  // delta
					this.delta = (FairPricingOutput) newValue;
					break;
				case 98120615:  // gamma
					this.gamma = (FairPricingOutput) newValue;
					break;
				case 2135544315:  // statisticalResults
					this.statisticalResults = (StatisticalResults) newValue;
					break;
				default:
					throw new NoSuchElementException("Unknown property: " + propertyName);
			}
			return this;
		}

		@Override
		public Builder set(MetaProperty<?> property, Object value) {
			super.set(property, value);
			return this;
		}

		@Override
		public PricingResults build() {
			return new PricingResults(this);
		}

		//-----------------------------------------------------------------------
		/**
		 * Sets the price.
		 * @param price  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder price(FairPricingOutput price) {
			JodaBeanUtils.notNull(price, "price");
			this.price = price;
			return this;
		}

		/**
		 * Sets the delta.
		 * @param delta  the new value, not null
		 * @return this, for chaining, not null
		 */
		public Builder delta(FairPricingOutput delta) {
			JodaBeanUtils.notNull(delta, "delta");
			this.delta = delta;
			return this;
		}

		/**
		 * Sets the gamma.
		 * @param gamma  the new value
		 * @return this, for chaining, not null
		 */
		public Builder gamma(FairPricingOutput gamma) {
			this.gamma = gamma;
			return this;
		}

		/**
		 * Sets the statisticalResults.
		 * @param statisticalResults  the new value
		 * @return this, for chaining, not null
		 */
		public Builder statisticalResults(StatisticalResults statisticalResults) {
			this.statisticalResults = statisticalResults;
			return this;
		}

		//-----------------------------------------------------------------------
		@Override
		public String toString() {
			StringBuilder buf = new StringBuilder(160);
			buf.append("PricingResults.Builder{");
			int len = buf.length();
			toString(buf);
			if (buf.length() > len) {
				buf.setLength(buf.length() - 2);
			}
			buf.append('}');
			return buf.toString();
		}

		protected void toString(StringBuilder buf) {
			buf.append("price").append('=').append(JodaBeanUtils.toString(price)).append(',').append(' ');
			buf.append("delta").append('=').append(JodaBeanUtils.toString(delta)).append(',').append(' ');
			buf.append("gamma").append('=').append(JodaBeanUtils.toString(gamma)).append(',').append(' ');
			buf.append("statisticalResults").append('=').append(JodaBeanUtils.toString(statisticalResults)).append(',').append(' ');
		}

	}

	//-------------------------- AUTOGENERATED END --------------------------
}
